/* 
 * Basic configuration page scripts
 */

function editChannel(chanNo, mode) {
    if (chanNo == 0){
        alert('No channel selected, or no channels available!');
        return 0;
    }
    var el = get_elem("editbox");
    chanData=get_val('application.channels.chan_'+chanNo).split(',');
    chanPort=chanData[1];

    chanPriorityOverMusic=defaultPriorityOverMusic;
    chanPriorityOverCall=defaultPriorityOverCall;
    chanDisplayAds=defaultDisplayAds;
    chanDisplayAdsWhenNoAudio=defaultDisplayAdsWhenNoAudio;
    chanFrameBufferSize=defaultFrameBufferSize;

    chanName = chanData[7];
    chanLogoURL = chanData[8];
    chanInput = chanData[9];
    chanStreamPort = chanData[10];
    encoder_output_ip = ""; 
    if(chanData.length >= 12){
        encoder_output_ip = chanData[11];
    }
    if (chanInput != "none") {
        chanIP=location.host;
        get_elem('edit_ip').disabled = true;
    } else {
        chanIP=chanData[0];
        get_elem('edit_ip').disabled = false;
    }

    // preset edit box values
    //set_txt('edit_chan',chanNo);
    // input fields
    set_val('edit_cn',chanName);
    set_val('edit_ip',chanIP);
    set_val('edit_port',chanPort);
    set_val('edit_fbs',chanFrameBufferSize);
    set_val('edit_clu',chanLogoURL);
    set_val('edit_strport', chanStreamPort);
    set_val('edit_encoder_output_ip', encoder_output_ip);
    // set the default values to be the same as the values also for the "validated" inputs
    // so that we can revert to them if the new edited values are not valid
    get_elem('edit_cn').defaultValue=chanName;
    get_elem('edit_ip').defaultValue=chanIP;
    get_elem('edit_port').defaultValue=chanPort;
    get_elem('edit_strport').defaultValue = chanStreamPort;
    get_elem('edit_clu').defaultValue = chanLogoURL;
    // select options
    get_elem('edit_aom').selectedIndex=chanPriorityOverMusic;
    get_elem('edit_aoc').selectedIndex=chanPriorityOverCall;
    get_elem('edit_ads').selectedIndex=chanDisplayAds;
    get_elem('edit_ana').selectedIndex=chanDisplayAdsWhenNoAudio;
    get_elem('edit_in').value = chanInput;
    console.log("encoder_output_ip: " + encoder_output_ip);
    if (encoder_output_ip == "") {
        get_elem('encoder_output_selector').value = "internal";
        get_elem('edit_encoder_output_ip').style.visibility="hidden";
    } else {
        get_elem('encoder_output_selector').value = "external";
        get_elem('edit_encoder_output_ip').style.visibility = "visible";
    }    
    // set the edit channel global variable
    editChan = chanNo;
    // set the edit mode global variable
    editMode = mode;

    loadInitialIcon();
    // show the dialog
    el.style.visibility = "visible";
}

function cancelEditBox(chanNo, mode){
    // hide the box without changing anything
    // This fild is hidden/shown idependently so I have to hide it here too
    get_elem('edit_encoder_output_ip').style.visibility="hidden";
    var el = get_elem("editbox");
    el.style.visibility = "hidden";
    if (mode == editModeEnum.ADD) {
        // remove temporary entry
        deleteAndShiftChan(chanNo);
    }
}

function closeEditBox(chanNo, mode) {
    // saves the channel settings and closes the edit box
    var el = get_elem("editbox");
    var chanId='application.channels.chan_'+chanNo;
    var newChanUciVal = '';
    var oldChanUciVal = get_val('application.channels.chan_'+chanNo);
    
    // store back the changed values
    newChanUciVal = newChanUciVal + get_val('edit_ip') + ',';
    newChanUciVal = newChanUciVal + get_val('edit_port') + ',';
    //newChanUciVal = newChanUciVal + get_val('edit_aom') + ',';
    newChanUciVal = newChanUciVal + defaultPriorityOverMusic + ',';
    //newChanUciVal = newChanUciVal + get_val('edit_aoc') + ',';
    newChanUciVal = newChanUciVal + defaultPriorityOverCall + ',';
    //newChanUciVal = newChanUciVal + get_val('edit_ads') + ',';
    newChanUciVal = newChanUciVal + defaultDisplayAds + ',';
    //newChanUciVal = newChanUciVal + get_val('edit_ana') + ',';
    newChanUciVal = newChanUciVal + defaultDisplayAdsWhenNoAudio + ',';
    newChanUciVal = newChanUciVal + defaultFrameBufferSize + ',';
    newChanUciVal = newChanUciVal + get_val('edit_cn') + ',';
    newChanUciVal = newChanUciVal + get_val('edit_clu') + ',';
    newChanUciVal = newChanUciVal + get_val('edit_in') + ',';
    newChanUciVal = newChanUciVal + get_val('edit_strport') + ',';
    // Set encoder output IP only if it is external
    var encoderOutputSelectorValue = get_val('encoder_output_selector');
    if (encoderOutputSelectorValue == "external" ) {
        newChanUciVal = newChanUciVal + get_val('edit_encoder_output_ip');
    } 
    set_val(chanId,newChanUciVal);

    if (mode == editModeEnum.ADD) {
        addChUCI(newChanUciVal);
    }
    else {
        editChUCI(oldChanUciVal, newChanUciVal);
    }

    // refresh channel table
    redrawChannelsTable();
    
    // hide the dialog
    el.style.visibility = "hidden";
    // This fild is hidden/shown idependently so I have to hide it here too
    get_elem('edit_encoder_output_ip').style.visibility="hidden";
}

function initPage(){

    /*
     * Cannot use onclick HTML attribute for it because one of arguments
     * is an object
     */
    get_elem('edit_channel').addEventListener("click", function() {editChannel(getSelectedChan(), editModeEnum.EDIT)}, false);
    createChannelHeader('channel_table');
    redrawChannelsTable();
}

function deleteAllChannels(){
    var numChans=parseInt(get_val('application.general.channel_count'),10);
    var chan;
    var confirmOk=confirm("Are you sure you want to delete all channels!");
    if (confirmOk == true) {
        for (chan=1;chan<=numChans;chan++){
            deleteAndShiftChan(1);
        }
        delAllChUCI();
   }
}

function deleteAndShiftChan(chanNo){
    var numChans=parseInt(get_val('application.general.channel_count'),10);
    var maxChans=parseInt(get_val('application.general.max_channels'),10);
    var chanDelId, chanNextId, k;
        
    // shift up channels
    for (k=chanNo;k<=maxChans;k++){
        chanDelId='application.channels.chan_'+k;
        chanNextId='application.channels.chan_'+(k+1);
            set_val(chanDelId,get_val(chanNextId));
        }
        // set channel 50 to empty (deleted)
        set_val('application.channels.chan_'+maxChans,'');
        if (numChans > 0) set_val('application.general.channel_count', --numChans);
        
        // refresh tables
        redrawChannelsTable();
}

function deleteChannel(chanNo) {
    var chData = get_val('application.channels.chan_'+chanNo);

    deleteAndShiftChan(chanNo);
    delChUCI(chData);
}

function addNewChannel(chanNo){
    var numChans=parseInt(get_val('application.general.channel_count'),10);
    var maxChans=parseInt(get_val('application.general.max_channels'),10);

    if (numChans == maxChans){
        alert ('You have reached the maximum number of channels, could not add this one!');
        return 0;
    }

    if (chanNo == 0) {
        chanNo=1;
    }

    var newChan;

    newChan=defaultIP+','+defaultPort+','+defaultPriorityOverMusic+',';
    newChan=newChan+defaultPriorityOverCall+','+defaultDisplayAds+',';  
    newChan=newChan+defaultDisplayAdsWhenNoAudio+','+defaultFrameBufferSize+',';
    newChan = newChan+defaultName+'-'+chanNo+','+defaultLogoURL+',';
    newChan = newChan+defaultInput+','+defaultStreamPort + ',' + defaultEncoderOutputIP;
    
    var chanDelId, chanNextId, p;
        
    // shift down channels
    for (p=maxChans-1;p >= chanNo;p--){
        chanToShiftId='application.channels.chan_'+p;
        chanShiftedId='application.channels.chan_'+(p+1);
        set_val(chanShiftedId,get_val(chanToShiftId));
    }
    // set the inserted channel
    set_val('application.channels.chan_'+chanNo,newChan);
    // set the correct number of channels
    set_val('application.general.channel_count', ++numChans);
    // refresh table
    redrawChannelsTable();
    // open the edit window
    editChannel(chanNo, editModeEnum.ADD);
}

function createChannelHeader(tableID){
    var newTable=get_elem(tableID);
    var tableHeader=channelsHeader;
    var headerRow;

    if (newTable.rows.length == 0){
        headerRow = newTable.insertRow(0);
        for (cellNo=0; cellNo < channelsHeader.length; cellNo++){
            newCell=headerRow.insertCell(cellNo); 
            newCell.innerHTML = tableHeader[cellNo];
        }
    }
}

function redrawChannelsTable(){
    var channelsTable=get_elem('channel_table');
    var numConfChannels=get_val('application.general.channel_count');
    var chanData=new Array();
    var newRow;
    var newCell;
    var channelCfgRef;
    var chanIP;
    var chanPort;
    var chanPriorityOverMusic;
    var chanPriorityOverCall;
    var chanDisplayAds;
    var chanDisplayAdsWhenNoAudio;
    var chanFrameBufferSize;
    var chanName;
    var chanLogoURL;
    var chanInput;
    var chanStreamPort;
    var buttonElem;
    
    clearTable(channelsTable);
    for (rowNo=1; rowNo<=numConfChannels; rowNo++){
        newRow=channelsTable.insertRow(channelsTable.rows.length);
        // create table cells
        for (cellNo=0; cellNo < channelsHeader.length; cellNo++){
            newCell=newRow.insertCell(cellNo); 
            newCell.innerHTML = "";
        }

        // update the contents
        // Take care that he referred names are the same as in the header array!
        // define param reference name
        // get raw channel data
        channelCfgRef='application.channels.chan_'+rowNo;
        chanData=get_val(channelCfgRef).split(',');
        chanPort=chanData[1];
        chanPriorityOverMusic=chanData[2];
        chanPriorityOverCall=chanData[3];
        chanDisplayAds=chanData[4];
        chanDisplayAdsWhenNoAudio=chanData[5];
        chanFrameBufferSize=chanData[6];
        chanName = chanData[7];
        chanLogoURL = chanData[8];
        chanInput = chanData[9];
        chanStreamPort = chanData[10];
        encoderOutputIP = "";
        if(chanData.length >= 12){
            encoderOutputIP = chanData[11];
        }
        if (chanInput != "none") {
            chanIP=location.host;
        } else {
            chanIP=chanData[0];
        }
    	
    	// create the radio button (for channel selection)
    	buttonElem = document.createElement("input");
		buttonElem.setAttribute('type','radio');
		buttonElem.setAttribute('value',rowNo);
		buttonElem.setAttribute('name','chan_sel');
		
		//channel selection button, always on first cell (no need for lookup index)
    	if (rowNo == 1){
    		//preselect the first channel
    		buttonElem.setAttribute('checked','checked');
    	}
    	// add the element in the cell
    	newRow.cells[0].appendChild(buttonElem);
    	
    	//all channel parameters
        newRow.cells[channelsHeader.indexOf("IP")].innerHTML = chanIP;
        newRow.cells[channelsHeader.indexOf("Subscription Port")].innerHTML = chanPort;
        newRow.cells[channelsHeader.indexOf("Local Input")].innerHTML = chanInput;
        //newRow.cells[channelsHeader.indexOf("Local Streaming Port")].innerHTML = chanStreamPort;
        newRow.cells[channelsHeader.indexOf("Streaming Port")].innerHTML = chanStreamPort;
        newRow.cells[channelsHeader.indexOf("Streamer Output IP")].innerHTML = encoderOutputIP;
	/*
    	if (chanPriorityOverMusic == 1){
    		newRow.cells[channelsHeader.indexOf("Audio Over Music")].innerHTML="Yes";
    	}else{
    		newRow.cells[channelsHeader.indexOf("Audio Over Music")].innerHTML="No";
    	}
    	if (chanPriorityOverCall == 1){
    		newRow.cells[channelsHeader.indexOf("Audio Over Call")].innerHTML="Yes";
    	}else{
    		newRow.cells[channelsHeader.indexOf("Audio Over Call")].innerHTML="No";
    	}
    	if (chanDisplayAds == 1){
    		newRow.cells[channelsHeader.indexOf("Channel Ads")].innerHTML="Yes";
    	}else{
    		newRow.cells[channelsHeader.indexOf("Channel Ads")].innerHTML="No";
    	}
    	if (chanDisplayAdsWhenNoAudio == 1){
    		newRow.cells[channelsHeader.indexOf("Ads When No Audio")].innerHTML="Yes";
    	}else{
    		newRow.cells[channelsHeader.indexOf("Ads When No Audio")].innerHTML="No";
    	}
    	newRow.cells[channelsHeader.indexOf("Frame Buffer Size")].innerHTML=chanFrameBufferSize;
	*/
    	newRow.cells[channelsHeader.indexOf("Channel Name")].innerHTML=chanName;
    	newRow.cells[channelsHeader.indexOf("Channel Logo URL")].innerHTML=chanLogoURL;
    	// set the wrapping of the URL. Use "break-all" as "break-word" wil not work as the URL may not have spaces!
    	// Firefox
    	//newRow.cells[channelsHeader.indexOf("Channel Logo URL")].style.wordWrap="break-word";
    	// Safari
    	newRow.cells[channelsHeader.indexOf("Channel Logo URL")].className="break";
    	// check if form has changed
    //evalFormChanged('settings');
    }
}

function clearTable(table) {
    var rows = table.rows;
    var i = rows.length;
    while (--i) {
        table.deleteRow(i);
    }
}

function make_get(URL) {
    var xmlHttp = new XMLHttpRequest();

    xmlHttp.open("GET", URL, true);
    xmlHttp.send(null);
}

function set_mode_UCI(ch_list_mode) {
    var URL = '/cgi-bin/set_uci.cgi?action=set_mode&mode='+ch_list_mode;

    make_get(URL);
}

function addChUCI(ch_data) {
    var URL = '/cgi-bin/set_uci.cgi?action=add&ch_data='+ch_data;

    make_get(URL);
}

function editChUCI(old_ch_data, new_ch_data) {
    var URL= '';

    URL = URL + '/cgi-bin/set_uci.cgi?action=edit&old_ch_data='+old_ch_data;
    URL = URL + '&new_ch_data='+new_ch_data;
    make_get(URL);
}

function delChUCI(ch_data) {
    var URL = '/cgi-bin/set_uci.cgi?action=del&ch_data='+ch_data;

    make_get(URL);
}

function delAllChUCI() {
    var URL = '/cgi-bin/set_uci.cgi?action=delall';

    make_get(URL);
}

function apply_changes() {
    var URL = '/cgi-bin/set_uci.cgi?action=apply';

    make_get(URL);
}

function cancel_changes() {
    var URL = '/cgi-bin/set_uci.cgi?action=cancel';

    make_get(URL);
}

function validateChannelsAndReturnErrorStringOrNull(){
	var subscriptionPorts = new Set();
    var channelNames = new Set();
    var localInputs = [];
    var streamingPorts = new Set();
	var numChans = parseInt(get_val('application.general.channel_count'),10);
    var msg = ""
    // Fill sets
	for (var i = 1; i <= numChans; i++) {
        chanData = get_val('application.channels.chan_' + i).split(',');
        subscriptionPorts.add(chanData[1]);
        channelNames.add(chanData[7]);
        localInputs.push(chanData[9]);
        streamingPorts.add(chanData[10]);
    }
    // Find duplicates
    if (subscriptionPorts.size != numChans){
        msg = "Error. Duplicated subscription ports."
        return msg
    }
    if (channelNames.size != numChans){
        msg = "Error. Duplicated channel names."
        return msg
    }
    if (streamingPorts.size != numChans){
        msg = "Error. Duplicated streaming ports."
        return msg
    }
    // Find duplicated left input
    var aux = [] 
    aux = localInputs.filter(function(it) {
        if (it == "left") {
            return true;
        }
        return false;
    })
    if (aux.length > 1){
        console.log("Error. Duplicated left input.")
    }
    // Find duplicated right input
    var aux = [] 
    aux = localInputs.filter(function(it) {
        if (it == "right") {
            return true;
        }
        return false;
    })
    if (aux.length > 1){
        msg = "Error. Duplicated right input."
        return msg
    }
    return null
}

function validateAndSendForm(){
    errStr = ""
    errStr = validateChannelsAndReturnErrorStringOrNull()
    if (errStr == null){
	    document.forms['settings'].submit();
    } else {
        alert(errStr);
    }
}


